load('GistPatches.mat');

addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))

imPath = '/lab/raid/models/AIM/infosaliency/';
files  = dir([imPath '*.jpg']);

dims = [512 512];
binSize = 20;

gistVectors = cell(length(files),1);

%%%%%
param.K=200;  % learns a dictionary with 100 elements
param.lambda=0.15;
param.numThreads=4; % number of threads
param.batchsize=400;

param.iter=2000;  % let us see what happens after 1000 iterations.

%%%%%%


for k=1:length(files)
    II=double((imread([imPath files(k).name])))/255;
    I = imresize(rgb2gray(II), [dims(1) dims(2)]);
    % extract 8 x 8 patches
    X=im2col(I,[8 8],'distinct');
    param.approx=0;
    D = DS{1};
    alpha=mexLasso(X,D,param);
    
    % %     % image reconstruction
    % %     rec = alpha'*D'; % recontructed image
    % %     %     Y=Y-repmat(mean(Y),[size(Y,1) 1]);
    % %     %     Y=Y ./ repmat(sqrt(sum(Y.^2)),[size(Y,1) 1]);
    % %
    % %     A = col2im(rec',[8 8],[dims(1) dims(2)], 'distinct');
    
    % make the gist
    
    QQ = full(alpha');
    tmp = [];
    
    for i=1:size(DS{1},2)
        tmp = [tmp hist(QQ(:,i),binSize)];
    end
    
    gistVectors{k} = tmp;
end