function [finalMapLG finalMapL finalMapG] = myNewModifiedModel(fileName, numScales, PS, InitScale)


param.lambda=0.15;
param.numThreads=4; % number of threads
param.batchsize=400;
param.iter=2000;  % let us see what happens after 1000 iterations.
useGlobal = 1;
useLocal = 1;

load(['DSBruceRGB200.mat']); % RGB
DSRGB = DS;

load(['DSBruce200.mat']); % Lab
DSLAB = DS;

blurRadius = 0.2;     % e.g. we can change blur radius
centerbias = 0; cbSize = 1;

weights = [1 1 1];
pS = PS; % window size
dims = [InitScale(1) InitScale(2)];ww = dims/8;

numBins = 100;

finalMapLG = ones(ww);
finalMapL = ones(ww);
finalMapG = ones(ww);
for colorSpace = 1:2 % RGB + LAB
    dims = [InitScale(1) InitScale(2)]; ww = dims/8;
    finalsalMapLG = ones(ww);
    finalsalMapL = ones(ww);
    finalsalMapG = ones(ww);
    
    % Looping through the scale space
    for scaleNo = 1:numScales
        %         figure;
        
        dims = dims/2;  ww = dims/8;
        overallsalMapLG = ones(ww);
        overallsalMapL = ones(ww);
        overallsalMapG = ones(ww);
        
        recImg = zeros(dims(1), dims(2),3);
        for m=1:3
            if colorSpace ==1
                DS = DSRGB;
                param.K=size(DS{1},2);  % learns a dictionary with 100 elements
                III=double((imread(fileName)))/255;
                I = imresize(III(:,:,m), [dims(1) dims(2)]);
            else
                DS = DSLAB;
                param.K=size(DS{1},2);  % learns a dictionary with 100 elements
                III=double((imread(fileName)))/255;
                II= RGB2Lab(III);
                I = imresize(II(:,:,m), [dims(1) dims(2)]);
            end
            
            
            % extract 8 x 8 patches
            X=im2col(I,[8 8],'distinct');
            param.approx=0;
            D = DS{m};
            alpha=mexLasso(X,D,param);
            rec = alpha'*D'; % recontructed image
            A = col2im(rec',[8 8],[dims(1) dims(2)], 'distinct');
            
            % Calculating saliency for each image implementing center-surround
            salMap = ones(ww(1),ww(2));
            kk = dims(1)/ww(1);
            
            % Calculating pdf's for each coeff in Alpha
            LL = full(alpha);
            RR = zeros(size(LL,1),numBins);
            ZZ = zeros(size(LL,1),numBins);
            
            for i=1:size(LL,1)
                [RR(i,:) ZZ(i,:)] = hist(LL(i,:),numBins);
            end
            
            salMapL = zeros(ww);
            salMapG = zeros(1,size(LL,2));
            tic
            if useGlobal >= 1 % Global Rarity -------------------------
                for prr=1:size(RR,1)
                    RR(prr,:) = RR(prr,:)/sum(RR(prr,:));
                end
                
                for p1=1:size(LL,2)
                    %tt = 0;
                    tmpZZ = zeros(size(LL,1),size(ZZ,2));
                    for p2=1:size(LL,1)
                        %[u v ] = min(abs(ZZ(p2,:) - LL(p2,p1)));
                        tmpZZ(p2,:)=abs(ZZ(p2,:) - LL(p2,p1));
                    end
                    [u v] = min(tmpZZ,[],2);
                    
                    myRR = zeros(size(LL,1),1);
                    for p2=1:size(LL,1)
                        %                         myRR(p2)=log(RR(p2,v(p2)));
                        myRR(p2)=abs(RR(p2,v(p2)));
                    end
                    tt = sum(myRR);
                    
                    salMapG(p1) = 1/tt;
                    %                     salMapG(p1) = 1- tt;
                end
                toc
                if min(salMapG) ~= max(salMapG)
                    salMapG = reshape(salMapG, [ww(1) ww(2)]);
                     salMapG = salMapG - min(min(salMapG)); salMapG = salMapG ./max(max(salMapG)); salMapG = mypeakiness( salMapG ) * salMapG;
                end
                
                salMapG = reshape(salMapG, [ww(1) ww(2)]);
            end
            
            
            tic
            if useLocal >= 1  % Local Rarity -------------------------
                kk = dims(1)/ww(1);
                zz = reshape(full(alpha), [size(D,2) ww(1) ww(2)]);
                
                for p1=1:ww(1)
                    for p2=1:ww(2)
                        
                        sumA = 0;
                        for jx=-pS:+pS
                            %                     for jx=[-pS 0 +pS]
                            for jy=-pS:+pS
                                %                         for jy=[-pS 0 +pS]
                                if jx==0 && jy==0;continue;end
                                if p1 + jx < 1;continue;end
                                if p1 + jx > ww(1);continue;end
                                if p2 + jy < 1;continue;end
                                if p2 + jy > ww(2);continue;end
                                
                                % dissimilarity measure
                                %                             sum = sum + pdist2([zz(:,p1,p2)]' , [zz(:,p1+jx,p2+jy)]');
                                we = 1/norm([jx jy]);
                                sumA = sumA + we * mean(abs([zz(:,p1,p2)]' - [zz(:,p1+jx,p2+jy)]'));
                                %              sum = sum + pdist2([alpha(:,p)]' , [alpha(:,p+(kk*jy)+jx)]');
                            end
                        end
                        salMapL(p1,p2) = sumA;
                    end
                end
                %                 subplot(3,3,(m-1)*3+2)
                %                 imshow(salMapL,[])
                 salMapL = salMapL - min(min(salMapL)); salMapL = salMapL ./max(max(salMapL)); salMapL = mypeakiness( salMapL ) * salMapL;
                %                 salMap = salMapL;
            end
            toc
            %   Local + Global          -----------------------------------------
            
            

%              salMapLG = min(salMapL,salMapG);
%                            salMapLG = salMapL + salMapG;
            
            
            % applying
%             wjLG = mypeakiness( salMapLG );
%             overallsalMapLG = overallsalMapLG + (weights(m)*wjLG*salMapLG);
            wjL = mypeakiness( salMapL );
            overallsalMapL = overallsalMapL + wjL*salMapL;
            wjG = mypeakiness( salMapG );
            overallsalMapG = overallsalMapG + wjG*salMapG;
            %             subplot(3,3,(m-1)*3+3)
            %             imshow(overallsalMap,[])
            
            recImg(:,:,m) = A;
            
        end % end m

        
        % Now adding local and global stuff
        
        wjL = mypeakiness( overallsalMapL );
        finalsalMapL = finalsalMapL + (wjL* imresize(overallsalMapL,[size(finalsalMapL,1) size(finalsalMapL,2)] ));% + wk*edgeMap;
        wjG = mypeakiness( overallsalMapG );
        finalsalMapG = finalsalMapG + (wjG* imresize(overallsalMapG,[size(finalsalMapG,1) size(finalsalMapG,2)] ));% + wk*edgeMap;
        
        wjL = mypeakiness( finalsalMapL); wjG = mypeakiness( finalsalMapG );
        overallsalMapLG = (wjL * finalsalMapL) + (wjG * finalsalMapG);
        wjLG = mypeakiness( overallsalMapLG );
        finalsalMapLG = finalsalMapLG + (wjLG* imresize(overallsalMapLG,[size(finalsalMapLG,1) size(finalsalMapLG,2)] ));% + wk*edgeMap;
        
        
    end % scaleNo
    
    finalsalMapLG = finalsalMapLG - min(min(finalsalMapLG));
    finalsalMapLG = finalsalMapLG ./max(max(finalsalMapLG));
    finalsalMapLG = mypeakiness( finalsalMapLG ) * finalsalMapLG;
    finalMapLG = finalMapLG + imresize(finalsalMapLG,[size(finalMapLG,1) size(finalMapLG,2)] );% + wk*edgeMap;
    
    finalsalMapL = finalsalMapL - min(min(finalsalMapL));
    finalsalMapL = finalsalMapL ./max(max(finalsalMapL));
    finalsalMapL = mypeakiness( finalsalMapL ) * finalsalMapL;
    finalMapL = finalMapL + imresize(finalsalMapL,[size(finalMapL,1) size(finalMapL,2)] );% + wk*edgeMap;
    
    
    finalsalMapG = finalsalMapG - min(min(finalsalMapG));
    finalsalMapG = finalsalMapG ./max(max(finalsalMapG));
    finalsalMapG = mypeakiness( finalsalMapG ) * finalsalMapG;
    finalMapG = finalMapG + imresize(finalsalMapG,[size(finalMapG,1) size(finalMapG,2)] );% + wk*edgeMap;
    
    
    
end % colors


% figure

% apply final blur ---------------------------------------------
if ( blurRadius > 0 )
    ker = mygausskernel( blurRadius * size(finalMapLG,1) , .1);
    finalMapLG = myconv2(myconv2(finalMapLG,ker),ker');
    finalMapL = myconv2(myconv2(finalMapL,ker),ker');
    finalMapG = myconv2(myconv2(finalMapG,ker),ker');
    
end

% apply global center bias ----------------------------------------
if ( centerbias )
    h = size(finalMapLG,1);
    w = size(finalMapLG,2);
    
    finalMapLG = finalMapLG .* (gausswin(h,cbSize) * gausswin(w,cbSize)');
    finalMapL = finalMapL .* (gausswin(h,cbSize) * gausswin(w,cbSize)');
    finalMapG = finalMapG .* (gausswin(h,cbSize) * gausswin(w,cbSize)');
end


finalMapLG = finalMapLG - min(min(finalMapLG)); finalMapLG = finalMapLG ./ max(max(finalMapLG));
finalMapL = finalMapL - min(min(finalMapL)); finalMapL = finalMapL ./ max(max(finalMapL));
finalMapG = finalMapG - min(min(finalMapG)); finalMapG = finalMapG ./ max(max(finalMapG));

end
















% backup area

% %                 for p1=1:size(LL,2)
% %                     tt = 0;
% %                     for p2=1:size(LL,1)
% %                         [u v ] = min(abs(ZZ(p2,:) - LL(p2,p1)));
% %                         %                    tt = tt + double(log1p(RR(p2,v(1))));
% %
% % %                         if RR(p2,v(1)) ==0 ; RR(p2,v(1)) =1; end
% % %                         tt = tt + (RR(p2,v(1)) );
% %
% %                         RR(p2,:) = RR(p2,:)/sum(RR(p2,:)); % pdf
% % %                         if RR(p2,v(1)) ==0 ; RR(p2,v(1)) =0.001; end
% %                         tt = tt + log(abs(RR(p2,v(1))));
% %                     end
% %                     salMapG(p1) = 1/tt;
% %
% % %                     salMapG(p1) = 1- tt;
% %
% %                 end




%                    tt = tt + double(log1p(RR(p2,v(1))));

%                         if RR(p2,v(1)) ==0 ; RR(p2,v(1)) =1; end
%                         tt = tt + (RR(p2,v(1)) );

%RR(p2,:) = RR(p2,:)/sum(RR(p2,:)); % pdf
%                         if RR(p2,v(1)) ==0 ; RR(p2,v(1)) =0.001; end
%tt = tt + log( abs(RR(p2,v(1))) );
