function finalMap = myNewSaLModel(fileName, useLocal, useGlobal)

if nargin ==1 
    useLocal = 0;
    useGlobal = 1;
end

param.lambda=0.15;
param.numThreads=4; % number of threads
param.batchsize=400;
param.iter=2000;  % let us see what happens after 1000 iterations.

load(['DSBruceRGB1000.mat']); % RGB
DSRGB = DS;

load(['DSBruce1000' '.mat']); % Lab
DSLAB = DS;

blurRadius = 0.2     % e.g. we can change blur radius
centerbias = 0; cbSize = 1;

weights = [1 1 1];
pS = 5;
dims = [512 512];ww = dims/8;

finalMap = ones(ww);
for colorSpace = 0:1 % RGB + LAB
    dims = [512 512]; ww = dims/8;
    finalsalMap = ones(ww);
    
    % Looping through the scale space
    for scaleNo = 1:3%4
        %         figure;
        
        dims = dims/2;  ww = dims/8;
        overallsalMap = ones(ww);
        
        recImg = zeros(dims(1), dims(2),3);
        for m=1:3
            if colorSpace ==1
                DS = DSRGB;
                param.K=size(DS{1},2);  % learns a dictionary with 100 elements
                III=double((imread(fileName)))/255;
                I = imresize(III(:,:,m), [dims(1) dims(2)]);
            else
                DS = DSLAB;
                param.K=size(DS{1},2);  % learns a dictionary with 100 elements
                III=double((imread(fileName)))/255;
                II= RGB2Lab(III);
                I = imresize(II(:,:,m), [dims(1) dims(2)]);
            end
            
            
            % extract 8 x 8 patches
            X=im2col(I,[8 8],'distinct');
            param.approx=0;
            D = DS{m};
            alpha=mexLasso(X,D,param);
            rec = alpha'*D'; % recontructed image
            A = col2im(rec',[8 8],[dims(1) dims(2)], 'distinct');
            
            % Calculating saliency for each image implementing center-surround
            salMap = ones(ww(1),ww(2));
            kk = dims(1)/ww(1);
            
            % Calculating pdf's for each coeff in Alpha
            LL = full(alpha);
            RR = zeros(size(LL,1),10);
            ZZ = zeros(size(LL,1),10);
            
            for i=1:size(LL,1)
                [RR(i,:) ZZ(i,:)] = hist(LL(i,:),10);
            end
            
            
            salMapL = zeros(ww);
            salMapG = zeros(1,size(LL,2));
            
            
            if useGlobal >= 1 % Global Rarity -------------------------
                
                for p1=1:size(LL,2)
                    tt = 0;
                    for p2=1:size(LL,1)
                        [u v ] = min(abs(ZZ(p2,:) - LL(p2,p1)));
                        %                    tt = tt + double(log1p(RR(p2,v(1))));
                        if RR(p2,v(1)) ==0 ; RR(p2,v(1)) =1; end
                        tt = tt + (RR(p2,v(1)) );
                    end
                    salMapG(p1) = 1-tt;
                end

                if min(salMapG) ~= max(salMapG)
                    
                    salMapG = reshape(salMapG, [ww(1) ww(2)]);
                    %                 subplot(3,3,(m-1)*3+1)
                    %                 imshow(salMapG,[])
                    
                    salMapG = salMapG - min(min(salMapG)); salMapG = salMapG ./max(max(salMapG)); salMapG = mypeakiness( salMapG ) * salMapG;
                end
            end
            
            
            if useLocal >= 1  % Local Rarity -------------------------
                
                kk = dims(1)/ww(1);
                zz = reshape(full(alpha), [size(D,2) ww(1) ww(2)]);
                
                for p1=1:ww(1)
                    for p2=1:ww(2)
                        
                        sumA = 0;
                        for jx=-pS:+pS
                            %                     for jx=[-pS 0 +pS]
                            for jy=-pS:+pS
                                %                         for jy=[-pS 0 +pS]
                                if jx==0 && jy==0;continue;end
                                if p1 + jx < 1;continue;end
                                if p1 + jx > ww(1);continue;end
                                if p2 + jy < 1;continue;end
                                if p2 + jy > ww(2);continue;end
                                
                                % dissimilarity measure
                                %                             sum = sum + pdist2([zz(:,p1,p2)]' , [zz(:,p1+jx,p2+jy)]');
                                we = 1/norm([jx jy]);
                                sumA = sumA + we * mean(abs([zz(:,p1,p2)]' - [zz(:,p1+jx,p2+jy)]'));
                                %              sum = sum + pdist2([alpha(:,p)]' , [alpha(:,p+(kk*jy)+jx)]');
                            end
                        end
                        salMapL(p1,p2) = sumA;
                    end
                end
                %                 subplot(3,3,(m-1)*3+2)
                %                 imshow(salMapL,[])
                salMapL = salMapL - min(min(salMapL)); salMapL = salMapL ./max(max(salMapL)); salMapL = mypeakiness( salMapL ) * salMapL;
                salMap = salMapL;
            end
            
            %   Local + Global          -----------------------------------------
            salMapG = reshape(salMapG, [ww(1) ww(2)]);
            
            if (useLocal ==1 )
                salMap = (useLocal*salMapL) .* (useGlobal*salMapG) ;
            else
                salMap = (useGlobal*salMapG) ;
            end
            
            
            % applying
            wj = mypeakiness( salMap );
            overallsalMap = overallsalMap + (weights(m)*wj*salMap);
            
            %             subplot(3,3,(m-1)*3+3)
            %             imshow(overallsalMap,[])
            
            recImg(:,:,m) = A;
            
        end % end m
        
        
        wj = mypeakiness( overallsalMap );
        finalsalMap = finalsalMap + (wj* imresize(overallsalMap,[size(finalsalMap,1) size(finalsalMap,2)] ));% + wk*edgeMap;
        
    end % scaleNo
    
    finalsalMap = finalsalMap - min(min(finalsalMap)); finalsalMap = finalsalMap ./max(max(finalsalMap)); finalsalMap = mypeakiness( finalsalMap ) * finalsalMap;
    %         wj = mypeakiness( finalsalMap );
    finalMap = finalMap + imresize(finalsalMap,[size(finalMap,1) size(finalMap,2)] );% + wk*edgeMap;
    
end % colors


% figure

% apply final blur ---------------------------------------------
if ( blurRadius > 0 )
    ker = mygausskernel( blurRadius * size(finalMap,1) , .1);
    finalMap = myconv2(myconv2(finalMap,ker),ker');
end

% apply global center bias ----------------------------------------
if ( centerbias )
    h = size(finalMap,1);
    w = size(finalMap,2);
    finalMap = finalMap .* (gausswin(h,cbSize) * gausswin(w,cbSize)');
end


finalMap = finalMap - min(min(finalMap));
finalMap = finalMap ./ max(max(finalMap));


end