AWSpath = '/lab/raid/models/OutputSaliency/SAWS/';
Houpath = '/lab/raid/models/OutputSaliency/SHouNIPS/';
fixpath = '/lab/raid/models/AIM/eyetrackingdata/fixdens/Density Maps produced from raw experimental eye tracking data/';

addpath(genpath('/lab/raid/models/GBVS/'))
addpath('/lab/borji/borji/projects/Superpixels/codes/simpsal');
addpath(genpath('/lab/borji/borji/projects/Superpixels/SPAMS/SPAMS/'))

imPath = '/lab/raid/models/AIM/infosaliency/';
files  = dir([imPath '*.jpg']);

param.K=100;  % learns a dictionary with 100 elements
param.lambda=0.15;
param.numThreads=4; % number of threads
param.batchsize=400;
param.iter=2000;  % let us see what happens after 1000 iterations.

useLocal = 0; useGlobal = 1;

close all % -------------------------
weights = [1 1 1];

for k=1:120%length(files)
    
    dims = [512 512];
    pS = 7;
    ww = dims/8;
    
    finalMap = ones(ww);
    for colorSpace = 0:1
        dims = [512 512];
        ww = dims/8;
        
        finalsalMap = ones(ww);
        
        % Looping through the scale space
        for scaleNo = 1:3%4
            figure;
            
            dims = dims/2;  ww = dims/8;
            overallsalMap = ones(ww);
            
            recImg = zeros(dims(1), dims(2),3);
            for m=1:3
                
                if colorSpace ==1
                    load(['DSBruceRGB50.mat'])
                    param.K=100;  % learns a dictionary with 100 elements
                    III=double((imread([imPath num2str(k) '.jpg'])))/255;
                    I = imresize(III(:,:,m), [dims(1) dims(2)]);
                    
                else
                    param.K=50;  % learns a dictionary with 100 elements
                    load(['DSBruce' num2str(param.K) '.mat'])
                    III=double((imread([imPath num2str(k) '.jpg'])))/255;
                    II= RGB2Lab(III);
                    I = imresize(II(:,:,m), [dims(1) dims(2)]);
                end
                
                
                % extract 8 x 8 patches
                X=im2col(I,[8 8],'distinct');
                param.approx=0;
                D = DS{m};
                alpha=mexLasso(X,D,param);
                rec = alpha'*D'; % recontructed image
                A = col2im(rec',[8 8],[dims(1) dims(2)], 'distinct');
                
                % Calculating saliency for each image implementing center-surround
                salMap = ones(ww(1),ww(2));
                kk = dims(1)/ww(1);
                
                
                PPP = 100;
                
                % Calculating pdf's for each coeff in Alpha
                LL = full(alpha);
                RR = zeros(size(LL,1),PPP);
                ZZ = zeros(size(LL,1),PPP);
                
                for i=1:size(LL,1)
                    [RR(i,:) ZZ(i,:)] = hist(LL(i,:),PPP);
                end
                
%                 figure; N = RR(12,:); X = ZZ(12,:); bar(X,N/sum(N)); hold on ; bar(X,N/sum(N),'r' );                
%                 figure; [f,xi] = ksdensity(RR(5,:)); plot(xi,f , 'b')                
                
                salMapL = zeros(ww);
                salMapG = zeros(1,size(LL,2));
                
                
                if useGlobal >= 1 % Global Rarity -------------------------
                    
                    for p1=1:size(LL,2)
                        tt = 0;
                        for p2=1:size(LL,1)
                            [u v ] = min(abs(ZZ(p2,:) - LL(p2,p1)));
                            %                    tt = tt + double(log1p(RR(p2,v(1))));
                            if RR(p2,v(1)) ==0 ; RR(p2,v(1)) =1; end
                            tt = tt + (RR(p2,v(1)) );
                        end
                        salMapG(p1) = 1-tt;
                    end
                    
                    salMapG = reshape(salMapG, [ww(1) ww(2)]);
                    subplot(3,3,(m-1)*3+1)
                    imshow(salMapG,[])
                    salMapG = salMapG - min(min(salMapG)); salMapG = salMapG ./max(max(salMapG)); salMapG = mypeakiness( salMapG ) * salMapG;
                end
                
                
                if useLocal >= 1  % Local Rarity -------------------------
                    
                    kk = dims(1)/ww(1);
                    zz = reshape(full(alpha), [size(D,2) ww(1) ww(2)]);
                    
                    for p1=1:ww(1)
                        for p2=1:ww(2)
                            
                            sumA = 0;
                            for jx=-pS:+pS
                                %                     for jx=[-pS 0 +pS]
                                for jy=-pS:+pS
                                    %                         for jy=[-pS 0 +pS]
                                    if jx==0 && jy==0;continue;end
                                    if p1 + jx < 1;continue;end
                                    if p1 + jx > ww(1);continue;end
                                    if p2 + jy < 1;continue;end
                                    if p2 + jy > ww(2);continue;end
                                    
                                    % dissimilarity measure
                                    %                             sum = sum + pdist2([zz(:,p1,p2)]' , [zz(:,p1+jx,p2+jy)]');
                                    we = 1/norm([jx jy]);
                                    sumA = sumA + we * mean(abs([zz(:,p1,p2)]' - [zz(:,p1+jx,p2+jy)]'));
                                    %              sum = sum + pdist2([alpha(:,p)]' , [alpha(:,p+(kk*jy)+jx)]');
                                end
                            end
                            salMapL(p1,p2) = sumA;
                        end
                    end
                    subplot(3,3,(m-1)*3+2)
                    imshow(salMapL,[])
                    salMapL = salMapL - min(min(salMapL)); salMapL = salMapL ./max(max(salMapL)); salMapL = mypeakiness( salMapL ) * salMapL;
                    salMap = salMapL;
                end
                
                %   Local + Global          -----------------------------------------
                salMapG = reshape(salMapG, [ww(1) ww(2)]);
                %                 salMap = (useLocal*salMapL) .* (useGlobal*salMapG) ;
                salMap = (useGlobal*salMapG) ;
                
                
                % applying
                wj = mypeakiness( salMap );
                overallsalMap = overallsalMap + (weights(m)*wj*salMap);
                
                subplot(3,3,(m-1)*3+3)
                imshow(overallsalMap,[])
                
                
                recImg(:,:,m) = A;
                
            end % end m
            
            
            wj = mypeakiness( overallsalMap );
            finalsalMap = finalsalMap .* (wj* imresize(overallsalMap,[size(finalsalMap,1) size(finalsalMap,2)] ));% + wk*edgeMap;
            
        end % scaleNo
        
        finalsalMap = finalsalMap - min(min(finalsalMap)); finalsalMap = finalsalMap ./max(max(finalsalMap)); finalsalMap = mypeakiness( finalsalMap ) * finalsalMap;
        %         wj = mypeakiness( finalsalMap );
        finalMap = finalMap + imresize(finalsalMap,[size(finalMap,1) size(finalMap,2)] );% + wk*edgeMap;
        
    end % colors
    
    finalsalMap = finalMap;
    
    figure
    
    %     AWS
    %         [a b] = myAWS(imresize(III, .5));
    %         a = imresize(a, [size(finalsalMap,1) size(finalsalMap,2)]);
    %         finalsalMap= finalsalMap + (a-min(min(a)))/max(max(a));
    %
    
    blurRadius = 0.2     % e.g. we can change blur radius
    centerbias = 0; cbSize = 1;
    
    % apply final blur ---------------------------------------------
    if ( blurRadius > 0 )
        ker = mygausskernel( blurRadius * size(finalsalMap,1) , .1);
        finalsalMap = myconv2(myconv2(finalsalMap,ker),ker');
    end
    
    % apply global center bias ----------------------------------------
    if ( centerbias )
        h = size(finalsalMap,1);
        w = size(finalsalMap,2);
        finalsalMap = finalsalMap .* (gausswin(h,cbSize) * gausswin(w,cbSize)');
    end
    
    
    subplot(3,3,4)
    imshow(imresize(III,[dims(1) dims(2)]))
    
    subplot(3,3,5)
    imshow(recImg,[])
    
    subplot(3,3,6)
    
    
    
    % Adding top-down factors --------------------------------------------------------
    
    % load Features.mat for Bruce.
    % load /lab/raid/models/Judd/Softwares/BruceFeatures.mat;
    %     imshow(reshape(Features{1,1}(:,29),[200 200]), []) % horizon
    useObjFeat =0;
    if useObjFeat ==1
        salMapHorizon = imresize(reshape(Features{1,1}(:,29),[200 200]), [size(finalsalMap,1) size(finalsalMap,2)]);
        salMapCar = imresize(reshape(Features{1,1}(:,30),[200 200]), [size(finalsalMap,1) size(finalsalMap,2)]); % car
        salMapPeople = imresize(reshape(Features{1,1}(:,31),[200 200]), [size(finalsalMap,1) size(finalsalMap,2)]); % people
        salMapFaces = imresize(reshape(Features{1,1}(:,32),[200 200]), [size(finalsalMap,1) size(finalsalMap,2)]); % faces
        salMapCenter = imresize(reshape(Features{1,1}(:,33),[200 200]), [size(finalsalMap,1) size(finalsalMap,2)]);
        salMapFeatures = 1-salMapCenter; % salMapHorizon + salMapCar + salMapPeople + salMapFaces;
        salMapFeatures = salMapFeatures - min(min(salMapFeatures));
        salMapFeatures = salMapFeatures ./ max(max(salMapFeatures));
    end
    
    
    
    %  --------------------------------------------------------
    
    
    finalsalMap = finalsalMap - min(min(finalsalMap)); finalsalMap = finalsalMap ./max(max(finalsalMap));
    %     finalsalMap = finalsalMap .* salMapFeatures;
    
    finalsalMap = imresize(finalsalMap, [size(III,1)  size(III,2)]);
    
    
    
    imshow(finalsalMap,[])
    
    subplot(3,3,7)
    sss = num2str(k);
    %     ii = findstr(sss, '.');
    q = load([AWSpath sss '.mat']);
    imshow(q.SaliencyMap,[])
    
    subplot(3,3,1)
    sss = num2str(k);
    q = imread([Houpath sss '.jpg']);
    imshow(q,[])
    
    
    subplot(3,3,8)
    sss = num2str(k);
    III = imread([fixpath 'd' sss '.jpg']);
    imshow(III,[])
    
    pause
    
    close all
    ff = ['/lab/raid/models/OutputSaliency/SNew/'  sss '.jpg'];
    finalMap = finalMap - min(min(finalMap));
    finalMap = finalMap ./ max(max(finalMap));
    
%     imwrite(finalMap,ff)
    
    figure;
    for k=1:3
        subplot(3,3,k)
        imshow(II(:,:,k),[])
    end
    
end
